/* MAME Cheat Database Converter Version 1.1B */
/* Coded by JCK from The Ultimate Patchers    */
/* Release date : 19th of November 1998       */

#include <stdio.h>
#include <string.h>

void DisplayHelp(char *ProgName)
{
  printf("Syntax : %s <CheatFileIn> [<CheatFileOut>]\n\n", ProgName);
}

int ExistFile(char *FileName)
{
  FILE *F;

  F = fopen(FileName,"r");
  if (!F)    /* If the file doesn't exist .... */
	return(0);
  else
  {
	fclose(F);
	printf("\nFile '%s' already exists ! ", FileName);
	printf("Do you want to overwrite it (y = YES) ? ");
	return(toupper(getchar()) == 'Y' ? 0 : 1);
  }
}

int main(int argc, char **argv)
{
  FILE *FI;
  FILE *FO;
  char *ptr;
  char SI[80];
  char SO[80];
  char fmt[32];
  char adrs[8];
  char CFI[80] = "";
  char CFO[80] = "";

  struct cheat_struct
  {
	char Game[80];
	int  CpuNo;
	int  Address;
	int  Data;
	int  Special;
	char Name[80];
  } Cheat;

  if (2 <= argc)    /* Copy the 1st parameter if it exists */
	strcpy(CFI, argv[1]);
  if (3 <= argc)    /* Copy the 2nd parameter if it exists */
	strcpy(CFO, argv[2]);

  if (!CFI[0])    /* No cheat file for input */
  {
	DisplayHelp(argv[0]);
	return(99);
  }

  if (!CFO[0])    /* No cheat file for output */
  {
	strcpy(SI, CFI);		/* We must make a copy of CFI because strtok changes it */
	ptr = strtok(SI, ".");	/* Extract the name of the file before the extension */
	strcpy(CFO, ptr);
	strcat(CFO,".out");	/* Add a .out extension */
  }

  if (!stricmp(CFI, CFO))
  {
	printf("Input and Output files must have a different name !\n\n");
	return(1);
  }

  FI = fopen(CFI,"r");    /* Open 1st file for input */

  if (!FI)
  {
	printf("\nUnable to read '%s' !\n\n", CFI);
	return(2);
  }

  if (ExistFile(CFO))
  {
	printf("\nFile '%s' not overwritten !\n\n", CFO);
	return(4);
  }

  FO = fopen(CFO,"w");    /* Open 2nd file for output */

  if (!FO)
  {
	printf("\nUnable to write '%s' !\n\n", CFO);
	return(3);
  }

  printf("\nConverting '%s' into '%s' .... ", CFI, CFO);
  for(;;)
  {
	if (fgets(SI, 80, FI) == NULL)
		break;

	#ifdef macintosh
	/* remove extraneous LF on Macs if it exists */
	if (SI[0] == '\r')
		strcpy(SI, &SI[1]);
	#endif

	if ((SI[0] == ';') || (SI[0] == '\n'))    /* Trap empty and comments lines */
	{
		strcpy(SO, SI);
		#ifdef macintosh
		/* force DOS-style line enders */
		strcat (SO, "\r");
		#endif
		fprintf(FO, "%s", SO);
	}
	else
	{
		ptr = strtok(SI, ":");			/* Extract the name of the game */
		strcpy (Cheat.Game, ptr);
		ptr = strtok(NULL, ":");		/* Extract the CPU */
		sscanf(ptr,"%d", &Cheat.CpuNo);
		ptr = strtok(NULL, ":");		/* Extract the address */
		sscanf(ptr,"%x", &Cheat.Address);
		strcpy (adrs, ptr);
		ptr = strtok(NULL, ":");		/* Extract the byte to poke */
		sscanf(ptr,"%x", &Cheat.Data);
		ptr = strtok(NULL, ":");		/* Extract the type of cheat */
		sscanf(ptr,"%d", &Cheat.Special);
		ptr = strtok(NULL, ":");		/* Extract the description */
		strcpy(Cheat.Name,ptr);
		Cheat.Name[strlen(Cheat.Name)-1] = 0;    /* Chop the terminal \n */
		switch (strlen(adrs))
		{
			case 4:
				strcpy (fmt, "%s:%d:%04X:%02X:%d:%s\n");
				break;
			case 5:
				strcpy (fmt, "%s:%d:%05X:%02X:%d:%s\n");
				break;
			case 6:
				Cheat.Address ^= 1;
				strcpy (fmt, "%s:%d:%06X:%02X:%d:%s\n");
				break;
			case 7:
				strcpy (fmt, "%s:%d:%07X:%02X:%d:%s\n");
				break;
			case 8:
				strcpy (fmt, "%s:%d:%08X:%02X:%d:%s\n");
				break;
			default:
				strcpy (fmt, "%s:%d:%X:%02X:%d:%s\n");
				break;
		}
		#ifdef macintosh
		/* force DOS-style line enders */
		strcat (fmt, "\r");
		#endif
		fprintf (FO, fmt, Cheat.Game, Cheat.CpuNo, Cheat.Address, Cheat.Data,
					Cheat.Special, Cheat.Name);
	}
  }

  fclose(FI);
  fclose(FO);

  printf("\nConversion ended !\n\n");
  return(0);
}
